#!/usr/bin/env python

'''
Not pretty, but shows how to use xpath to test for existance of a
subtag using lxml elementtree interface.
'''

import sys, os
from lxml import etree 
from StringIO import StringIO

xmlStr='''<?xml version="1.0" encoding="utf-8"?>
<ais-binary-message version="1.0">
  <message name="sampleMsg">
    <field name="dac" numberofbits="16" type="uint">
      <required>366</required>
    </field>
  </message>
</ais-binary-message>'''

et = etree.parse(StringIO(xmlStr)).getroot()

fields = et.xpath("/ais-binary-message/message[@name='sampleMsg']/field[@name='dac']")
print len(fields)
field = fields[0]

def hasSubtag(et,subtag):
    '''
    @return: true if the tag a sub tag with name subtag
    '''
    if 0<len(et.xpath(subtag)): return True
    return False

print 'has required:',hasSubtag(field,'required')
print 'has     junk:',hasSubtag(field,'junk')


